{-# OPTIONS_GHC -Wno-orphans #-}

{-|
Module:             TestUTF8
Description:        Test normalizing various cases of non-normalized UTF8.
Copyright:          © 2016 All rights reserved.
License:            GPL-3
Maintainer:         Evan Cofsky <evan@theunixman.com>
Stability:          experimental
Portability:        POSIX
-}

module TestNormalization where

import Test.Framework (Test)
import Test.HUnit hiding (Test)
import Control.Lens hiding (strict)
import ParseNormalizationTest
import Data.Text.ICU.Normalized.NFC
import Data.Text.Lens (unpacked)
import qualified Data.Text as T
import Test.Framework.Providers.HUnit

normalizationTests ∷ IO [Test]
normalizationTests = do
    (Right tcs) ← loadTestCodePoints
    return
        $ concatMapOf traversed (\p → over traversed (testNormalization p) (p ^. pTestCodePoints)) tcs


testNormalization ∷ Part → TestCodePoint → Test
testNormalization p tcp =
    testCase ((T.unwords [(p ^. pPartComment),
                          (tcp ^. tcComment)]) ^. unpacked)
    ((tcp ^. tcNFC) @?= (tcp ^. tcSource ^.re normalized ^. normalized))
